<template>
	<v-container class="sampling-collection-create flex-grow-1" :class="{ 'px-0': $vuetify.breakpoint.smAndDown }">
		<v-skeleton-loader v-if="isLoading" type="card" min-height="500px" />
		<v-card v-else-if="hasError && isLoaded" rounded="lg">
			<v-card-text> Error loading resources </v-card-text>
		</v-card>
		<v-card v-else-if="isLoaded" rounded="lg" class="overflow-hidden">
			<collect-map
				v-if="area && mapLocations"
				:area="area"
				:locations="{
					type: 'FeatureCollection',
					features: locationsWithStatus,
				}"
				:activeLocation="activeLocation"
				:hasGeolocateControl="true"
				:hasInteractiveLocations="true"
				@locationClick="onLocationClick"
				@trackUserLocationStart="onTrackUserLocationStart"
				@trackUserLocationEnd="onTrackUserLocationEnd"
				:hasProgress="true"
				@clickProgress="progressDialogIsVisible = true"
			/>
			<v-card-title v-if="activeLocation" class="d-flex justify-space-between align-start">
				<div>
					<div>Location {{ activeLocation.properties.label }}</div>
					<div v-if="activeLocation.properties.stratum" class="text-body-2">
						Stratum: {{ activeLocation.properties.stratum }}
					</div>
					<div v-if="activeLocation.properties.composite" class="text-body-2">
						Composite: {{ activeLocation.properties.composite }}
					</div>
					<div v-if="activeLocation.properties.bulkDensityRequired" class="text-body-2">Bulk Density Required</div>
				</div>
				<div v-if="distanceToActiveLocation" class="text-body-1">
					<v-icon> mdi-vector-line </v-icon>
					<span
						:class="{
							'error--text': distanceToActiveLocation > 20,
							'success--text': distanceToActiveLocation < 10,
						}"
					>
						{{ localizeDistance(distanceToActiveLocation).toFixed(2) }}
					</span>
					&nbsp;±
					<span
						:class="{
							'error--text': userLocation.coords.accuracy > 20,
							'success--text': userLocation.coords.accuracy < 10,
						}"
					>
						{{ localizeDistance(userLocation.coords.accuracy).toFixed(2) }}
					</span>
					&nbsp;{{ distanceUnit }}
				</div>
			</v-card-title>
			<v-card-text>
				<collect-sampling-button
					v-if="activeLocation && samplingCollection"
					:location="activeLocation"
					:userLocation="userLocation"
					:samples="activeSamples"
					:sampling="activeSampling"
					:samplingCollectionId="samplingCollectionId"
					:samplingCollection="samplingCollection"
					:creating="creating"
					@samplingCreate="onSamplingCreate"
					@samplingDelete="onSamplingDelete"
				/>
				<div v-else>
					<div>Select a location on the map to collect.</div>
				</div>
			</v-card-text>
		</v-card>
		<sampling-collection-submit
			v-if="field && samplingCollectionStatus === 'DRAFT'"
			:locations="{
				type: 'FeatureCollection',
				features: locationsWithStatus,
			}"
			:field="field"
			:samplingCollection="samplingCollection"
			:samplings="samplings"
			:samples="samples"
		/>
		<v-dialog v-model="progressDialogIsVisible" scrollable>
			<sampling-list
				:samplingsByLocation="samplingsByLocationId"
				:samplesByLocation="samplesByLocationId"
				:locationsById="locationsById"
				@closeDialog="progressDialogIsVisible = false"
				@exportSamplingCollection="exportRawSamplingCollection"
				@downloadLabInventory="exportLabInventory"
			/>
		</v-dialog>
		<v-dialog
			:value="isOutOfBounds && !isOutOfBoundsAcknowledged"
			@click:outside="acknowledgeOutOfBounds"
			max-width="50em"
		>
			<v-card>
				<v-toolbar color="grey lighten-2" flat>
					<v-toolbar-title>Outside of Map Bounds</v-toolbar-title>
				</v-toolbar>
				<v-divider />
				<v-card-text class="py-4">
					<div class="d-flex justify-center align-center mt-4 mx-2">
						<v-icon color="warning">mdi-exclamation-thick</v-icon>
						<v-divider vertical class="mx-2" />
						<p class="mt-0 mb-0">
							You are currently located outside of the map bounds. Please move closer to the field to see your location
							on the map.
						</p>
					</div>
				</v-card-text>
				<v-divider />
				<v-card-actions class="d-flex flex-wrap justify-end">
					<v-btn text rounded @click="acknowledgeOutOfBounds">OK</v-btn>
				</v-card-actions>
			</v-card>
		</v-dialog>
	</v-container>
</template>

<script lang="ts" src="./SamplingCollectionEdit.ts" />

<style scoped></style>
